#!/bin/sh
#
# UNIteX Print Filter Install Proguram
#
#	Copyright UNIteX.JAPAN CO., LTD
#	%W% %D%
#
# Modify 1999/05/17 HP-UX CD-ROM install support : K.Hatakeda
# Modify 2006/02/01 UPF V3 support : K.Hatakeda
#

PATH=$PATH:/usr/ucb
export PATH
if [ -f /usr/ucb/echo ]; then
    ECHO=/usr/ucb/echo
elif [ -f /bin/echo ]; then
    ECHO=/bin/echo
else
    ECHO=echo
fi
count=0
for c in `$ECHO -n xxx` ; do
    count=`expr $count + 1`
done
if [ "$count" = 1 ]; then
    ECHON="$ECHO -n"
else
    ECHON=${TMPDIR-/tmp}/echon.sh
    $ECHO "#!/bin/sh" > $ECHON
    $ECHO "$ECHO \"\$*\\\c\"" >> $ECHON
    chmod 0755 $ECHON
fi

if [ -f /usr/sony/bin/eject ]; then
    EJECT=/usr/sony/bin/eject
elif [ -f /usr/bin/eject ]; then
    EJECT=/usr/bin/eject
elif [ -f /bin/eject ]; then
    EJECT=/bin/eject
else
    EJECT=
fi

#
# Check super user.
#
installer=`whoami`
if [ "$installer" != "root" ]; then
    $ECHO ""
    $ECHO "Execute root(super user) !!"
    $ECHO "Package installing is failed."
    exit 1
fi

#
# Show title message.
#
$ECHO ""
$ECHO "UPF Package Installing Script Start"
$ECHO ""

#
# Input temporary directory.
#
while [ "$PKGTMPDIR" = "" ]; do
    $ECHO ""
    $ECHO "Enter temporary directory [default:/tmp]"
    $ECHON "? "
    read res
    if [ "$res" != "" ]; then
	case "$res" in
	    q*|Q*)
		$ECHO ""
		$ECHO "Package installing is failed."
		exit 1
		;;
	    *)
		;;
	esac
	if [ -d $res ]; then
	    PKGTMPDIR=$res
	fi
    else
	PKGTMPDIR=/tmp
    fi
done
PKGTMPDIR=$PKGTMPDIR/upfpkgtmp
if [ -d $PKGTMPDIR ]; then
    rm -rf $PKGTMPDIR
fi
mkdir $PKGTMPDIR
chmod 0777 $PKGTMPDIR

#
# Input floppy device.
#
#DEF_DEVICE=
#DEVICE=
#while [ "$DEVICE" = "" ]; do
#    $ECHO ""
#    if [ "$DEF_DEVICE" != "" ]; then
#	$ECHO "Enter install media device [default:$DEF_DEVICE]"
#	$ECHON "? /dev/"
#    else
#	$ECHON "Enter install media device ? /dev/"
#    fi
#    read res
#    if [ "$res" != "" ]; then
#	if [ "$res" = "." ]; then
#	    # current directory
#	    break
#	fi
#	DEVICE=/dev/$res
#	if [ ! -c $DEVICE -a ! -f $DEVICE ]; then
#	    DEVICE=
#	fi
#    else
#	if [ "$DEF_DEVICE" != "" ]; then
#	    DEVICE=$DEF_DEVICE
#	    if [ ! -c $DEF_DEVICE -a ! -f $DEF_DEVICE ]; then
#		DEVICE=
#	    fi
#	fi
#    fi
#done
#if [ "$DEVICE" = "" ]; then
#    FDDIR=`pwd`
#else
#    FDDIR=$PKGTMPDIR
#fi

# devide is "." 2006.03.22 K.Hatakeda
FDDIR=`pwd`


#
# Load package media.
#
INDEX=1
MEDIA_COUNT=
if [ "$MEDIA_COUNT" != "" ]; then
    while [ "$DEVICE" != "" ]; do
	$ECHO ""
	$ECHO "Please set package media (volume no:$INDEX/$MEDIA_COUNT)."
	$ECHON "O.K. [RETURN] "
	read res
	while [ true ]; do
	    $ECHO ""
	    $ECHON "Loading package media (volume no:$INDEX/$MEDIA_COUNT) ... "
	    (cd $PKGTMPDIR ; tar xf $DEVICE)
	    if [ $? = 0 ]; then
		break
	    fi
	    $ECHO ""
	    $ECHO "Media access error !!"
	    $ECHON "Retry [quit:q]? "
	    read res
	    case "$res" in
		q*|Q*)
		    rm -rf $PKGTMPDIR
		    $ECHO ""
		    $ECHO "Package installing is failed."
		    exit 1
		    ;;
		*)
		    ;;
	    esac
	done
	$ECHO "done"
	INDEX=`expr $INDEX + 1`
	if [ $INDEX -gt $MEDIA_COUNT ]; then
	    msg=on
	    if [ "$EJECT" != "" ]; then
		$EJECT $DEVICE 2> /dev/null
		if [ $? = 0 ]; then
		    msg=
		fi
	    fi
	    if [ "$msg" != "" ]; then
		$ECHO ""
		$ECHO "Please eject floppy."
		$ECHON "O.K. [RETURN] "
		read res
	    fi
	    break
	else
	    msg=on
	    if [ "$EJECT" != "" ]; then
		$EJECT $DEVICE 2> /dev/null
		if [ $? = 0 ]; then
		    msg=
		fi
	    fi
	    if [ "$msg" != "" ]; then
		$ECHO ""
		$ECHO "Please eject floppy."
		$ECHON "O.K. [RETURN] "
		read res
	    fi
	fi
    done
    if [ $MEDIA_COUNT -eq 1 ]; then
	zcat $FDDIR/UPFPKG.tar.Z | (cd $PKGTMPDIR ; tar xf - install)
    else
	cat $FDDIR/UPFPKG.tar.Z.* | zcat | (cd $PKGTMPDIR ; tar xf - install)
    fi
else
    while [ "$DEVICE" != "" ]; do
	$ECHO ""
	$ECHON "Loading form media ... "
	if [ -f UPFPKG.TAZ ]; then
	    cp UPFPKG.TAZ $PKGTMPDIR/UPFPKG.tar.Z
	else
	    (cd $PKGTMPDIR ; tar xf $DEVICE UPFPKG.tar.Z)
	fi
	if [ $? != 0 ]; then
	    $ECHO ""
	    $ECHO "Media access error !!"
	    $ECHON "Retry [quit:q]? "
	    read res
	    case "$res" in
	    q*|Q*)
		rm -rf $PKGTMPDIR
		$ECHO ""
		$ECHO "Package installing is failed."
		exit 1
		;;
	    *)
		;;
	    esac
	else
	    $ECHO "done"
	    if [ "$EJECT" != "" ]; then
		$EJECT $DEVICE 2> /dev/null
	    fi
	    break
	fi
    done
    if [ -f UPFPKG.TAZ ]; then
	cp UPFPKG.TAZ $PKGTMPDIR/UPFPKG.tar.Z
	zcat $PKGTMPDIR/UPFPKG.tar.Z | (cd $PKGTMPDIR ; tar xf - install)
    else
	zcat $FDDIR/UPFPKG.tar.Z | (cd $PKGTMPDIR ; tar xf - install)
    fi
fi
PACKAGES=
packages=`cd $PKGTMPDIR/install; ls`
for pkg in $packages; do
    if [ -d $PKGTMPDIR/install/$pkg ]; then
	case "$pkg" in
	    tool)
		PACKAGES="$pkg $PACKAGES"
		;;
	    *)
		PACKAGES="$PACKAGES $pkg"
		;;
	esac
     fi
done
cat $PKGTMPDIR/install/copyright

#
# Input install directory.
#
DEF_INSTALL=/usr/local
while [ "$INSTALLDIR" = "" ]; do
    $ECHO ""
    $ECHO "Enter install directory [default:$DEF_INSTALL]"
    $ECHON "? "
    read res
    if [ "$res" != "" ]; then
	case "$res" in
	    q*|Q*)
		rm -rf $PKGTMPDIR
		$ECHO ""
		$ECHO "Package installing is failed."
		exit 1
		;;
	    *)
		;;
	esac
	if [ -d $res ]; then
	    INSTALLDIR=$res
	else
	    $ECHO ""
	    $ECHO "Invalid directory !!"
	fi
    else
	INSTALLDIR=$DEF_INSTALL
    fi
done

#
# Package contents
#
packages=$PACKAGES
$ECHO ""
$ECHO "Package Contents:"
for pkg in $packages; do
    PKGINFO=$PKGTMPDIR/install/$pkg/pkginfo
    PKG=`awk -F"=" '{if($1 == "PKG"){print $2; exit}}' $PKGINFO`
    NAME=`awk -F"=" '{if($1 == "NAME"){print $2; exit}}' $PKGINFO`
    $ECHO "    $PKG		$NAME"
done

#
# Install packages.
#
for pkg in $PACKAGES; do
    PKGINFO=$PKGTMPDIR/install/$pkg/pkginfo
    PKG=`awk -F"=" '{if($1 == "PKG"){print $2; exit}}' $PKGINFO`
    NAME=`awk -F"=" '{if($1 == "NAME"){print $2; exit}}' $PKGINFO`
    $ECHO ""
    $ECHO "Installing $PKG ($NAME)"
    $ECHON "[yes:y/no:n/quit:q]? "
    read res
    case "$res" in
	q*|Q*)
	    rm -rf $PKGTMPDIR
	    $ECHO ""
	    $ECHO "Package installing is failed."
	    exit 1
	    ;;
	n*|N*)
	    continue
	    ;;
	*)
	    if [ "$pkg" != "tool" ]; then
		if [ -f $PKGTMPDIR/UPF/bin/setPasswd ]; then
		    rm -rf $PKGTMPDIR
		    $ECHO ""
		    $ECHO "UPF-CORE Package not installing."
		    $ECHO "Package installing is failed."
		    exit 1
		fi
	    fi
	    ;;
    esac
    #
    # Execute request script
    #
    REQUEST=$PKGTMPDIR/install/$pkg/request
    if [ -f $REQUEST ]; then
	chmod 0755 $REQUEST
	. $REQUEST
    fi
    #
    # Load filter package.
    #
    $ECHO ""
    $ECHO "Installing $PKG ..."
    PROTOTYPE=$PKGTMPDIR/install/$pkg/prototype
    crtLine=1
    maxLine=`wc -l $PROTOTYPE | awk '{print $1}'`
    LOAD_FILES=
    while [ $crtLine -le $maxLine ]; do
	content=`sed -n -e "$crtLine p" $PROTOTYPE`
	type=`$ECHO $content | awk '{print $1}'`
	case "$type" in
	    d)
		file=`$ECHO $content | awk '{print $3}'`
		if [ ! -d $INSTALLDIR/$file ]; then
		    mkdir $INSTALLDIR/$file
		    mode=`$ECHO $content | awk '{print $4}'`
		    chmod $mode $INSTALLDIR/$file
		    mode=`$ECHO $content | awk '{print $5}'`
		    chown $mode $INSTALLDIR/$file
		    mode=`$ECHO $content | awk '{print $6}'`
		    chgrp $mode $INSTALLDIR/$file
		fi
		;;
	    f)
		file=`$ECHO $content | awk '{print $3}'`
		file=`$ECHO $file | awk -F"=" '{print $1}'`
		LOAD_FILES="$LOAD_FILES $file"
		;;
	    *)
		;;
	esac
	crtLine=`expr $crtLine + 1`
    done
    if [ "$MEDIA_COUNT" != "" ]; then
	if [ $MEDIA_COUNT -eq 1 ]; then
	    if [ -f UPFPKG.TAZ ]; then
		cp UPFPKG.TAZ $PKGTMPDIR/UPFPKG.tar.Z
		zcat $PKGTMPDIR/UPFPKG.tar.Z | \
			(cd $INSTALLDIR ; tar xvf - $LOAD_FILES)
	    else
		zcat $FDDIR/UPFPKG.tar.Z | \
			(cd $INSTALLDIR ; tar xvf - $LOAD_FILES)
	    fi
	else
	    cat $FDDIR/UPFPKG.tar.Z.* | zcat | \
			(cd $INSTALLDIR ; tar xvf - $LOAD_FILES)
	fi
    else
	if [ -f UPFPKG.TAZ ]; then
		cp UPFPKG.TAZ $PKGTMPDIR/UPFPKG.tar.Z
		zcat $PKGTMPDIR/UPFPKG.tar.Z | \
			(cd $INSTALLDIR ; tar xvf - $LOAD_FILES)
	else
		zcat $FDDIR/UPFPKG.tar.Z | \
			(cd $INSTALLDIR ; tar xvf - $LOAD_FILES)
	fi
    fi
    $ECHO "done"
    #
    # Execute postinstall script
    #
    POSTINSTALL=$PKGTMPDIR/install/$pkg/postinstall
    UPFBINDIR=$INSTALLDIR/UPF/bin
    UPFLIBDIR=$INSTALLDIR/UPF/lib
    SETPASSWD=$UPFBINDIR/setPasswd
    PRINTER=$pkg
    if [ -f $POSTINSTALL ]; then
	chmod 0755 $POSTINSTALL
	. $POSTINSTALL
    fi
    #
    # Set access mode.
    #
    crtLine=1
    while [ $crtLine -le $maxLine ]; do
	content=`sed -n -e "$crtLine p" $PROTOTYPE`
	type=`$ECHO $content | awk '{print $1}'`
	case "$type" in
	    f)
		file=`$ECHO $content | awk '{print $3}'`
		file=`$ECHO $file | awk -F"=" '{print $1}'`
		mode=`$ECHO $content | awk '{print $4}'`
		chmod $mode $INSTALLDIR/$file
		mode=`$ECHO $content | awk '{print $5}'`
		chown $mode $INSTALLDIR/$file
		mode=`$ECHO $content | awk '{print $6}'`
		chgrp $mode $INSTALLDIR/$file
		;;
	    *)
		;;
	esac
	crtLine=`expr $crtLine + 1`
    done
    #
    # Set PCL/PCLC Config File Link.
    #
    if [ -f $UPFLIBDIR/upfpcl.cfg ]; then
	if [ ! -d /etc/UPF ]; then
	    mkdir /etc/UPF
	fi
	if [ -f /etc/UPF/upfpcl.cfg ]; then
	    rm /etc/UPF/upfpcl.cfg
	fi
	ln -s $UPFLIBDIR/upfpcl.cfg /etc/UPF/upfpcl.cfg
    fi
done

#
# Exit install
#
rm -rf $PKGTMPDIR
if [ -f "$ECHON" ]; then
    rm $ECHON
fi
$ECHO ""
$ECHO "Package installing is successful."
exit 0
